/* icode-common.h
 * Common part of instruction definition.
 *
 * Copyright (c) 1996 T. J. Wilkinson & Associates, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Tim Wilkinson <tim@tjwassoc.demon.co.uk>, 1997.
 */

#ifndef __icode_common_h
#define __icode_common_h

/*
 * These are for handling unknown types.
 */
#define	move_any			move_ref
#define	move_anylong			move_long
#define	load_any			load_int
#define load_offset_any			load_offset_int
#define	load_anylong			load_long
#define	store_any			store_int
#define store_offset_any		store_offset_int
#define	store_anylong			store_long

/*
 * These are architecture specific.
 * References may be int's or long's depending on the machine.
 */
#if defined(HAVE_ref_eq_int)
#define	move_ref_const(DST, PTR)	move_int_const(DST, (jint)(PTR))
#define	move_ref			move_int
#define	load_ref			load_int
#define	store_ref			store_int
#define	load_offset_ref			load_offset_int
#define	store_offset_ref		store_offset_int
#define	add_ref_const			add_int_const
#define	add_ref				add_int
#define	cmp_ref_const(DST, B, C)	cmp_int_const(DST, B, (jint)(C));
#define	cmp_ref				cmp_int
#define	return_ref			return_int
#define	returnarg_ref			returnarg_int
#define pusharg_long_idx_inc		2
#elif defined(HAVE_ref_eq_long)
#define pusharg_long_idx_inc		1
#endif

#endif
