/*
 * external_wrappers.h
 * Wrap up the calls between Kaffe and native method calls for systems
 *  which don't support shared libraries.
 *
 * Copyright (c) 1996 T. J. Wilkinson & Associates, London, UK.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Attila Molnar <gusthy@hu.bonus.com>, 1996.
 * Modified by Tim Wilkinson <tim@tjwassoc.demon.co.uk>, 1996.
 */

#ifndef __external_wrappers_h
#define __external_wrappers_h

#if defined(TRANSLATOR)
#define	KAFFEFUNC(_f)			_f
#define	KAFFE_NATIVE_METHOD(_n)		{ #_n, _n }
#elif defined(INTERPRETER)
#define	KAFFEFUNC(_f)			Kaffe_##_f##_stub
#define	KAFFE_NATIVE_METHOD(_n)		{ #_n, Kaffe_##_n##_stub }
#endif

extern KAFFEFUNC(java_util_Date_toString)();
extern KAFFEFUNC(java_util_Date_toLocaleString)();
extern KAFFEFUNC(java_util_Date_toGMTString)();
extern KAFFEFUNC(java_util_Date_expand)();
extern KAFFEFUNC(java_util_Date_computeValue)();
extern KAFFEFUNC(java_lang_ClassLoader_init)();
extern KAFFEFUNC(java_lang_ClassLoader_defineClass0)();
extern KAFFEFUNC(java_lang_ClassLoader_resolveClass0)();
extern KAFFEFUNC(java_lang_ClassLoader_findSystemClass0)();
extern KAFFEFUNC(java_lang_Class_forName)();
extern KAFFEFUNC(java_lang_Class_newInstance)();
extern KAFFEFUNC(java_lang_Class_getName)();
extern KAFFEFUNC(java_lang_Class_getSuperclass)();
extern KAFFEFUNC(java_lang_Class_getInterfaces)();
extern KAFFEFUNC(java_lang_Class_getClassLoader)();
extern KAFFEFUNC(java_lang_Class_isInterface)();
extern KAFFEFUNC(java_lang_Compiler_initialize)();
extern KAFFEFUNC(java_lang_Compiler_compileClass)();
extern KAFFEFUNC(java_lang_Compiler_compileClasses)();
extern KAFFEFUNC(java_lang_Compiler_command)();
extern KAFFEFUNC(java_lang_Compiler_enable)();
extern KAFFEFUNC(java_lang_Compiler_disable)();
extern KAFFEFUNC(java_lang_Double_toString)();
extern KAFFEFUNC(java_lang_Double_valueOf)();
extern KAFFEFUNC(java_lang_Double_doubleToLongBits)();
extern KAFFEFUNC(java_lang_Double_longBitsToDouble)();
extern KAFFEFUNC(java_lang_Float_toString)();
extern KAFFEFUNC(java_lang_Float_valueOf)();
extern KAFFEFUNC(java_lang_Float_floatToIntBits)();
extern KAFFEFUNC(java_lang_Float_intBitsToFloat)();
extern KAFFEFUNC(java_lang_Math_sin)();
extern KAFFEFUNC(java_lang_Math_cos)();
extern KAFFEFUNC(java_lang_Math_tan)();
extern KAFFEFUNC(java_lang_Math_asin)();
extern KAFFEFUNC(java_lang_Math_acos)();
extern KAFFEFUNC(java_lang_Math_atan)();
extern KAFFEFUNC(java_lang_Math_exp)();
extern KAFFEFUNC(java_lang_Math_log)();
extern KAFFEFUNC(java_lang_Math_sqrt)();
extern KAFFEFUNC(java_lang_Math_IEEEremainder)();
extern KAFFEFUNC(java_lang_Math_ceil)();
extern KAFFEFUNC(java_lang_Math_floor)();
extern KAFFEFUNC(java_lang_Math_rint)();
extern KAFFEFUNC(java_lang_Math_atan2)();
extern KAFFEFUNC(java_lang_Math_pow)();
extern KAFFEFUNC(java_lang_Object_getClass)();
extern KAFFEFUNC(java_lang_Object_hashCode)();
extern KAFFEFUNC(java_lang_Object_clone)();
extern KAFFEFUNC(java_lang_Object_notify)();
extern KAFFEFUNC(java_lang_Object_notifyAll)();
extern KAFFEFUNC(java_lang_Object_wait)();
extern KAFFEFUNC(java_lang_ProcessReaper_waitForDeath)();
extern KAFFEFUNC(java_lang_Runtime_exitInternal)();
extern KAFFEFUNC(java_lang_Runtime_execInternal)();
extern KAFFEFUNC(java_lang_Runtime_freeMemory)();
extern KAFFEFUNC(java_lang_Runtime_totalMemory)();
extern KAFFEFUNC(java_lang_Runtime_gc)();
extern KAFFEFUNC(java_lang_Runtime_runFinalization)();
extern KAFFEFUNC(java_lang_Runtime_traceInstructions)();
extern KAFFEFUNC(java_lang_Runtime_traceMethodCalls)();
extern KAFFEFUNC(java_lang_Runtime_initializeLinkerInternal)();
extern KAFFEFUNC(java_lang_Runtime_buildLibName)();
extern KAFFEFUNC(java_lang_Runtime_loadFileInternal)();
extern KAFFEFUNC(java_lang_SecurityManager_getClassContext)();
extern KAFFEFUNC(java_lang_SecurityManager_currentClassLoader)();
extern KAFFEFUNC(java_lang_SecurityManager_classDepth)();
extern KAFFEFUNC(java_lang_SecurityManager_classLoaderDepth)();
extern KAFFEFUNC(java_lang_System_currentTimeMillis)();
extern KAFFEFUNC(java_lang_System_arraycopy)();
extern KAFFEFUNC(java_lang_System_initProperties)();
extern KAFFEFUNC(java_lang_Thread_currentThread)();
extern KAFFEFUNC(java_lang_Thread_yield)();
extern KAFFEFUNC(java_lang_Thread_sleep)();
extern KAFFEFUNC(java_lang_Thread_start)();
extern KAFFEFUNC(java_lang_Thread_isAlive)();
extern KAFFEFUNC(java_lang_Thread_countStackFrames)();
extern KAFFEFUNC(java_lang_Thread_setPriority0)();
extern KAFFEFUNC(java_lang_Thread_stop0)();
extern KAFFEFUNC(java_lang_Thread_suspend0)();
extern KAFFEFUNC(java_lang_Thread_resume0)();
extern KAFFEFUNC(java_lang_Throwable_printStackTrace0)();
extern KAFFEFUNC(java_lang_Throwable_fillInStackTrace)();
extern KAFFEFUNC(java_lang_UNIXProcess_exec)();
extern KAFFEFUNC(java_lang_UNIXProcess_fork)();
extern KAFFEFUNC(java_lang_UNIXProcess_waitForUNIXProcess)();
extern KAFFEFUNC(java_lang_UNIXProcess_destroy)();
extern KAFFEFUNC(java_io_FileDescriptor_valid)();
extern KAFFEFUNC(java_io_FileDescriptor_initSystemFD)();
extern KAFFEFUNC(java_io_FileInputStream_open)();
extern KAFFEFUNC(java_io_FileInputStream_read)();
extern KAFFEFUNC(java_io_FileInputStream_readBytes)();
extern KAFFEFUNC(java_io_FileInputStream_skip)();
extern KAFFEFUNC(java_io_FileInputStream_available)();
extern KAFFEFUNC(java_io_FileInputStream_close)();
extern KAFFEFUNC(java_io_FileOutputStream_open)();
extern KAFFEFUNC(java_io_FileOutputStream_write)();
extern KAFFEFUNC(java_io_FileOutputStream_writeBytes)();
extern KAFFEFUNC(java_io_FileOutputStream_close)();
extern KAFFEFUNC(java_io_File_exists0)();
extern KAFFEFUNC(java_io_File_canWrite0)();
extern KAFFEFUNC(java_io_File_canRead0)();
extern KAFFEFUNC(java_io_File_isFile0)();
extern KAFFEFUNC(java_io_File_isDirectory0)();
extern KAFFEFUNC(java_io_File_lastModified0)();
extern KAFFEFUNC(java_io_File_length0)();
extern KAFFEFUNC(java_io_File_mkdir0)();
extern KAFFEFUNC(java_io_File_renameTo0)();
extern KAFFEFUNC(java_io_File_delete0)();
extern KAFFEFUNC(java_io_File_list0)();
extern KAFFEFUNC(java_io_File_isAbsolute)();
extern KAFFEFUNC(java_io_RandomAccessFile_open)();
extern KAFFEFUNC(java_io_RandomAccessFile_read)();
extern KAFFEFUNC(java_io_RandomAccessFile_readBytes)();
extern KAFFEFUNC(java_io_RandomAccessFile_write)();
extern KAFFEFUNC(java_io_RandomAccessFile_writeBytes)();
extern KAFFEFUNC(java_io_RandomAccessFile_getFilePointer)();
extern KAFFEFUNC(java_io_RandomAccessFile_seek)();
extern KAFFEFUNC(java_io_RandomAccessFile_length)();
extern KAFFEFUNC(java_io_RandomAccessFile_close)();

extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketCreate)();
extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketBind)();
extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketSend)();
extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketPeek)();
extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketReceive)();
extern KAFFEFUNC(java_net_DatagramSocket_datagramSocketClose)();
extern KAFFEFUNC(java_net_InetAddress_getLocalHostName)();
extern KAFFEFUNC(java_net_InetAddress_makeAnyLocalAddress)();
extern KAFFEFUNC(java_net_InetAddress_lookupHostAddr)();
extern KAFFEFUNC(java_net_InetAddress_lookupAllHostAddr)();
extern KAFFEFUNC(java_net_InetAddress_getHostByAddr)();
extern KAFFEFUNC(java_net_InetAddress_getInetFamily)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketCreate)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketConnect)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketBind)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketListen)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketAccept)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketAvailable)();
extern KAFFEFUNC(java_net_PlainSocketImpl_socketClose)();
extern KAFFEFUNC(java_net_SocketInputStream_socketRead)();
extern KAFFEFUNC(java_net_SocketOutputStream_socketWrite)();

/*
 * Name each method.
 */
nativeFunction default_natives[] = {

	/* tjwassoc.demon.co.uk/APIcore */

	KAFFE_NATIVE_METHOD(java_util_Date_toString),
	KAFFE_NATIVE_METHOD(java_util_Date_toLocaleString),
	KAFFE_NATIVE_METHOD(java_util_Date_toGMTString),
	KAFFE_NATIVE_METHOD(java_util_Date_expand),
	KAFFE_NATIVE_METHOD(java_util_Date_computeValue),
	KAFFE_NATIVE_METHOD(java_lang_ClassLoader_init),
	KAFFE_NATIVE_METHOD(java_lang_ClassLoader_defineClass0),
	KAFFE_NATIVE_METHOD(java_lang_ClassLoader_resolveClass0),
	KAFFE_NATIVE_METHOD(java_lang_ClassLoader_findSystemClass0),
	KAFFE_NATIVE_METHOD(java_lang_Class_forName),
	KAFFE_NATIVE_METHOD(java_lang_Class_newInstance),
	KAFFE_NATIVE_METHOD(java_lang_Class_getName),
	KAFFE_NATIVE_METHOD(java_lang_Class_getSuperclass),
	KAFFE_NATIVE_METHOD(java_lang_Class_getInterfaces),
	KAFFE_NATIVE_METHOD(java_lang_Class_getClassLoader),
	KAFFE_NATIVE_METHOD(java_lang_Class_isInterface),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_initialize),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_compileClass),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_compileClasses),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_command),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_enable),
	KAFFE_NATIVE_METHOD(java_lang_Compiler_disable),
	KAFFE_NATIVE_METHOD(java_lang_Double_toString),
	KAFFE_NATIVE_METHOD(java_lang_Double_valueOf),
	KAFFE_NATIVE_METHOD(java_lang_Double_doubleToLongBits),
	KAFFE_NATIVE_METHOD(java_lang_Double_longBitsToDouble),
	KAFFE_NATIVE_METHOD(java_lang_Float_toString),
	KAFFE_NATIVE_METHOD(java_lang_Float_valueOf),
	KAFFE_NATIVE_METHOD(java_lang_Float_floatToIntBits),
	KAFFE_NATIVE_METHOD(java_lang_Float_intBitsToFloat),
	KAFFE_NATIVE_METHOD(java_lang_Math_sin),
	KAFFE_NATIVE_METHOD(java_lang_Math_cos),
	KAFFE_NATIVE_METHOD(java_lang_Math_tan),
	KAFFE_NATIVE_METHOD(java_lang_Math_asin),
	KAFFE_NATIVE_METHOD(java_lang_Math_acos),
	KAFFE_NATIVE_METHOD(java_lang_Math_atan),
	KAFFE_NATIVE_METHOD(java_lang_Math_exp),
	KAFFE_NATIVE_METHOD(java_lang_Math_log),
	KAFFE_NATIVE_METHOD(java_lang_Math_sqrt),
	KAFFE_NATIVE_METHOD(java_lang_Math_IEEEremainder),
	KAFFE_NATIVE_METHOD(java_lang_Math_ceil),
	KAFFE_NATIVE_METHOD(java_lang_Math_floor),
	KAFFE_NATIVE_METHOD(java_lang_Math_rint),
	KAFFE_NATIVE_METHOD(java_lang_Math_atan2),
	KAFFE_NATIVE_METHOD(java_lang_Math_pow),
	KAFFE_NATIVE_METHOD(java_lang_Object_getClass),
	KAFFE_NATIVE_METHOD(java_lang_Object_hashCode),
	KAFFE_NATIVE_METHOD(java_lang_Object_clone),
	KAFFE_NATIVE_METHOD(java_lang_Object_notify),
	KAFFE_NATIVE_METHOD(java_lang_Object_notifyAll),
	KAFFE_NATIVE_METHOD(java_lang_Object_wait),
	KAFFE_NATIVE_METHOD(java_lang_ProcessReaper_waitForDeath),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_exitInternal),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_execInternal),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_freeMemory),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_totalMemory),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_gc),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_runFinalization),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_traceInstructions),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_traceMethodCalls),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_initializeLinkerInternal),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_buildLibName),
	KAFFE_NATIVE_METHOD(java_lang_Runtime_loadFileInternal),
	KAFFE_NATIVE_METHOD(java_lang_SecurityManager_getClassContext),
	KAFFE_NATIVE_METHOD(java_lang_SecurityManager_currentClassLoader),
	KAFFE_NATIVE_METHOD(java_lang_SecurityManager_classDepth),
	KAFFE_NATIVE_METHOD(java_lang_SecurityManager_classLoaderDepth),
	KAFFE_NATIVE_METHOD(java_lang_System_currentTimeMillis),
	KAFFE_NATIVE_METHOD(java_lang_System_arraycopy),
	KAFFE_NATIVE_METHOD(java_lang_System_initProperties),
	KAFFE_NATIVE_METHOD(java_lang_Thread_currentThread),
	KAFFE_NATIVE_METHOD(java_lang_Thread_yield),
	KAFFE_NATIVE_METHOD(java_lang_Thread_sleep),
	KAFFE_NATIVE_METHOD(java_lang_Thread_start),
	KAFFE_NATIVE_METHOD(java_lang_Thread_isAlive),
	KAFFE_NATIVE_METHOD(java_lang_Thread_countStackFrames),
	KAFFE_NATIVE_METHOD(java_lang_Thread_setPriority0),
	KAFFE_NATIVE_METHOD(java_lang_Thread_stop0),
	KAFFE_NATIVE_METHOD(java_lang_Thread_suspend0),
	KAFFE_NATIVE_METHOD(java_lang_Thread_resume0),
	KAFFE_NATIVE_METHOD(java_lang_Throwable_printStackTrace0),
	KAFFE_NATIVE_METHOD(java_lang_Throwable_fillInStackTrace),
	KAFFE_NATIVE_METHOD(java_lang_UNIXProcess_exec),
	KAFFE_NATIVE_METHOD(java_lang_UNIXProcess_fork),
	KAFFE_NATIVE_METHOD(java_lang_UNIXProcess_waitForUNIXProcess),
	KAFFE_NATIVE_METHOD(java_lang_UNIXProcess_destroy),
	KAFFE_NATIVE_METHOD(java_io_FileDescriptor_valid),
	KAFFE_NATIVE_METHOD(java_io_FileDescriptor_initSystemFD),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_open),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_read),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_readBytes),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_skip),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_available),
	KAFFE_NATIVE_METHOD(java_io_FileInputStream_close),
	KAFFE_NATIVE_METHOD(java_io_FileOutputStream_open),
	KAFFE_NATIVE_METHOD(java_io_FileOutputStream_write),
	KAFFE_NATIVE_METHOD(java_io_FileOutputStream_writeBytes),
	KAFFE_NATIVE_METHOD(java_io_FileOutputStream_close),
	KAFFE_NATIVE_METHOD(java_io_File_exists0),
	KAFFE_NATIVE_METHOD(java_io_File_canWrite0),
	KAFFE_NATIVE_METHOD(java_io_File_canRead0),
	KAFFE_NATIVE_METHOD(java_io_File_isFile0),
	KAFFE_NATIVE_METHOD(java_io_File_isDirectory0),
	KAFFE_NATIVE_METHOD(java_io_File_lastModified0),
	KAFFE_NATIVE_METHOD(java_io_File_length0),
	KAFFE_NATIVE_METHOD(java_io_File_mkdir0),
	KAFFE_NATIVE_METHOD(java_io_File_renameTo0),
	KAFFE_NATIVE_METHOD(java_io_File_delete0),
	KAFFE_NATIVE_METHOD(java_io_File_list0),
	KAFFE_NATIVE_METHOD(java_io_File_isAbsolute),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_open),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_read),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_readBytes),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_write),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_writeBytes),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_getFilePointer),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_seek),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_length),
	KAFFE_NATIVE_METHOD(java_io_RandomAccessFile_close),

	/* tjwassoc.demon.co.uk/APInet */

	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketCreate),
	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketBind),
	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketSend),
	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketPeek),
	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketReceive),
	KAFFE_NATIVE_METHOD(java_net_DatagramSocket_datagramSocketClose),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_getLocalHostName),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_makeAnyLocalAddress),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_lookupHostAddr),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_lookupAllHostAddr),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_getHostByAddr),
	KAFFE_NATIVE_METHOD(java_net_InetAddress_getInetFamily),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketCreate),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketConnect),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketBind),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketListen),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketAccept),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketAvailable),
	KAFFE_NATIVE_METHOD(java_net_PlainSocketImpl_socketClose),
	KAFFE_NATIVE_METHOD(java_net_SocketInputStream_socketRead),
	KAFFE_NATIVE_METHOD(java_net_SocketOutputStream_socketWrite),

	{ 0, 0 }
};

#endif
